#include <stdio.h>
#include <stdlib.h>

int main()
{
    long n;
    long u=0, uo=0, o2, uab=0, ab2, ua=0, a2, ub=0, b2;
    scanf("%ld", &n);
    long o, a, b, ab;
    scanf("%ld %ld %ld %ld", &o, &a, &b, &ab);
    long m[n][2];
    for (long i=0; i < n; i++)
    {
            char c[2];
            long x;
            scanf("%s %ld", &c, &x);
            if (c[0]=='O')
                {
                    m[i][0]=0;
                    m[i][1]=x;
                    uo += x;
                }
            if (c[0]=='A')
                {
                    if (c[1]=='B')
                    {
                        m[i][0]=3;
                        m[i][1]=x;
                        uab += x;
                    }
                    else
                    {
                        m[i][0]=1;
                        m[i][1]=x;
                        ua += x;
                    }
                }

            if (c[0]=='B')
                {
                    m[i][0]=2;
                    m[i][1]=x;
                    ub += x;
                }
            u += x;
        }
    int f=0;
    o2 = o;
    ab2 = ab;
    a2 = a;
    b2 = b;
    long dO=0, da=0, db=0; /// sve su dopune za AB, da-> koliko A dupunjuje AB ...
    if (u > (o + a + b + ab))
        printf("nemoguce");
    else
    {
        if (uo > o)
            printf("nemoguce");
        else
        {
            o -= uo;
            if (ua > a + o)
                printf("nemoguce");
            else
                {
                    if (ua > a)
                        {
                            o = o - ua + a;
                            a = 0;
                        }
                    else
                        a = a-ua;

                    if (ub > b + o)
                        printf("nemoguce");
                    else
                    {
                        if (ub > b)
                            {
                                o = o -ub + b;
                                b = 0;
                            }
                        else
                            b = b - ub;

                        if (uab > ab + o + a + b)
                            printf("nemoguce");
                        else
                        {
                            if (uab > ab)
                            {
                                if (uab < ab +a)
                                    da = ab + a - uab;
                                else
                                {
                                    if (uab < ab + a + b)
                                        db = ab + a + b - uab;
                                    else
                                    {
                                        dO = ab + a + b + o - uab;
                                    }
                                }
                            }

                            printf("moguce \n");
                            f=1;
                        }
                    }
                }
        }
        if (f==1)
        {
            long m2[n][4];
            for (int i=0; i < n; i++)
            {
                if (m[i][0]==0)  /// O
                    printf("%d %d %d %d \n", uo, 0, 0, 0);
                if (m[i][0]==1) /// A
                {
                    if (ua < a2)
                        printf("%d %d %d %d \n", 0, ua, 0, 0);
                    else
                    {
                        printf("%d %d %d %d \n", o2-ua+a2, a2, 0, 0);
                    }
                }
                if (m[i][0]==2)   /// B
                {
                   if (ub < b2)
                        printf("%d %d %d %d \n", 0, 0, ub, 0);
                    else
                    {
                        printf("%d %d %d %d \n", o2-ub+b2, 0, b2, 0);
                    }
                }
                if (m[i][0]==3)     /// AB
                {
                    if (uab < ab)
                        printf("%d %d %d %d \n", 0, 0, 0, ab);
                    else
                    {
                        printf("%d %d %d %d \n", dO, da, db, ab);
                    }
                }
            }
        }
    }

}